package com.spark.kafka.mongo.controller;

import com.spark.kafka.mongo.service.SparkKafkaProducer;
import com.spark.kafka.mongo.util.SparkMongoConsumer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/product")
public class ProductController {

    @Autowired
    SparkKafkaProducer sparkKafkaProducer;

    @Autowired
    SparkMongoConsumer sparkMongoConsumer;

    @GetMapping(value = "/publishToKafka")
    public String publishToKafka() {
        sparkKafkaProducer.publishMessages();
        return "Data published to Kafka Topic Successfully";
    }

    @GetMapping(value = "/saveToDB")
    public String saveToDB() {
        sparkMongoConsumer.getProductDataAndSave();
        return "Data Persisted Successfully into MongoDB";
    }
}
