package com.spark.kafka.mongo.service;

import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;
import org.apache.spark.sql.SparkSession;
import org.apache.spark.sql.functions;
import org.apache.spark.storage.StorageLevel;
import org.springframework.stereotype.Service;


@Service
public class SparkKafkaProducer {

    private static String KafkaBrokerEndpoint = "localhost:9092";
    private static String KafkaTopic = "products";
    private static String csvFile = "products.csv";

    public void publishMessages() {
        SparkSession session = SparkSession
                .builder().master("local[*]").appName("CSV-Kafka").getOrCreate();
        Dataset<Row> rowDataset = session.read().
                format("csv").option("header", true).
                load("src/main/resources/" + csvFile);
        Dataset<Row> KafkaPublish = rowDataset
                .withColumn("value", functions.to_json(functions.struct(functions.col("productId"),
                        functions.col("productName"), functions.col("productPrice"),
                        functions.col("deliveryStatus"))))
                .alias("value").select("value")
                .persist(StorageLevel.MEMORY_AND_DISK());
        KafkaPublish
                .write()
                .format("kafka")
                .option("kafka.bootstrap.servers", KafkaBrokerEndpoint)
                .option("topic", KafkaTopic)
                .save();
    }

}
